function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _object_spread_props(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
import { relationList } from "./field";
import { extractDirectedRelation } from "./helpers";
import { afterDocumentDelete } from "./hooks";
export var biDirectionalRelationship = function(config) {
    var _extractDirectedRelation = extractDirectedRelation(config, "A->B"), here = _extractDirectedRelation.here, there = _extractDirectedRelation.there;
    var _obj, _obj1;
    return {
        config: config,
        anchors: (_obj = {}, _define_property(_obj, here.collection, relationList(config, "A->B")), _define_property(_obj, there.collection, relationList(config, "B->A")), _obj),
        hooks: (_obj1 = {}, _define_property(_obj1, here.collection, afterDocumentDelete(config, "A->B")), _define_property(_obj1, there.collection, afterDocumentDelete(config, "B->A")), _obj1)
    };
};
export var biDirectionalRelationships = function(relationships) {
    return function(incomingConfig) {
        var _incomingConfig_i18n_resources, _incomingConfig_i18n, _incomingConfig_i18n_resources1, _incomingConfig_i18n1;
        var _incomingConfig_i18n_resources_de, _incomingConfig_i18n_resources_en;
        return _object_spread_props(_object_spread({}, incomingConfig), {
            collections: (incomingConfig.collections || []).map(function(collection) {
                var _collection_hooks;
                var _collection_hooks_afterDelete;
                return _object_spread_props(_object_spread({}, collection), {
                    hooks: _object_spread_props(_object_spread({}, collection.hooks), {
                        afterDelete: _to_consumable_array((_collection_hooks_afterDelete = (_collection_hooks = collection.hooks) === null || _collection_hooks === void 0 ? void 0 : _collection_hooks.afterDelete) !== null && _collection_hooks_afterDelete !== void 0 ? _collection_hooks_afterDelete : []).concat(_to_consumable_array(relationships.filter(function(relationship) {
                            return Object.keys(relationship.hooks).includes(collection.slug);
                        }).map(function(relationship) {
                            return relationship.hooks[collection.slug];
                        })))
                    })
                });
            }),
            i18n: {
                resources: {
                    de: _object_spread_props(_object_spread({}, (_incomingConfig_i18n_resources_de = (_incomingConfig_i18n = incomingConfig.i18n) === null || _incomingConfig_i18n === void 0 ? void 0 : (_incomingConfig_i18n_resources = _incomingConfig_i18n.resources) === null || _incomingConfig_i18n_resources === void 0 ? void 0 : _incomingConfig_i18n_resources.de) !== null && _incomingConfig_i18n_resources_de !== void 0 ? _incomingConfig_i18n_resources_de : {}), {
                        biDirectionalRelationships: {
                            validationError: "Es gibt bereits eine Beziehung zu diesem Element. Duplikate sind nicht erlaubt."
                        }
                    }),
                    en: _object_spread_props(_object_spread({}, (_incomingConfig_i18n_resources_en = (_incomingConfig_i18n1 = incomingConfig.i18n) === null || _incomingConfig_i18n1 === void 0 ? void 0 : (_incomingConfig_i18n_resources1 = _incomingConfig_i18n1.resources) === null || _incomingConfig_i18n_resources1 === void 0 ? void 0 : _incomingConfig_i18n_resources1.en) !== null && _incomingConfig_i18n_resources_en !== void 0 ? _incomingConfig_i18n_resources_en : {}), {
                        biDirectionalRelationships: {
                            validationError: "There is already a relation to this element. Duplicates are not allowed."
                        }
                    })
                }
            }
        });
    };
};

//# sourceMappingURL=index.js.map